import pandas as pd
import matplotlib.pyplot as plt
from matplotlib_venn import venn2
from matplotlib_venn import venn2_unweighted
import os
import argparse
# Lecture des données des fichiers BED

parser = argparse.ArgumentParser(description=" Script to generate VennPlot ")
parser.add_argument('-bed1', type=str, help="Path to bed1 file " )
parser.add_argument('-bed2', type=str, help='Path to bed2 file ')

args = parser.parse_args()
bed1 = args.bed1
bed2 = args.bed2


filename1 = os.path.splitext(os.path.basename(bed1))[0]
filename2 = os.path.splitext(os.path.basename(bed2))[0]

bed1_data = pd.read_csv(bed1, sep='\t', names=['Chro', 'Start', 'End'])
bed2_data = pd.read_csv(bed2, sep='\t', names=['Chro', 'Start', 'End'])

# Conversion des colonnes 'Start' et 'End' en tuples (pour la comparaison)
bed1_intervals = [(start, end) for start, end in zip(bed1_data['Start'], bed1_data['End'])]
bed2_intervals = [(start, end) for start, end in zip(bed2_data['Start'], bed2_data['End'])]

# Création des ensembles
set1 = set(bed1_intervals)
set2 = set(bed2_intervals)

# Calcul de l'intersection et des ensembles uniques
intersection = set1 & set2
unique_set1 = set1 - set2
unique_set2 = set2 - set1

# Compter les éléments des ensembles
count1 = len(unique_set1)
count2 = len(unique_set2)
count3 = len(intersection)

# Construction du diagramme de Venn
venn2_unweighted(subsets=(count1, count2, count3), set_labels=(filename1, filename2))
plt.title("")

# Afficher le diagramme
plt.show()
